"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extractGluestackConfig = extractGluestackConfig;
var _utils = require("@gluestack-style/react/lib/commonjs/utils");
var _createConfig = require("@gluestack-style/react/lib/commonjs/createConfig");
var _updateOrderUnResolvedMap = require("@gluestack-style/react/lib/commonjs/updateOrderUnResolvedMap");
var _convertSxToSxVerbosed = require("@gluestack-style/react/lib/commonjs/convertSxToSxVerbosed");
var _styleSheet = require("@gluestack-style/react/lib/commonjs/style-sheet");
var _propertyTokenMap = require("@gluestack-style/react/lib/commonjs/propertyTokenMap");
//@ts-ignore

//@ts-ignore

const {
  stableHash
} = require('@gluestack-style/react/lib/commonjs/stableHash');
//@ts-ignore

//@ts-ignore

function extractGlobalStyles(CONFIG = {}, theme = {}) {
  const GluestackStyleSheet = new _styleSheet.StyleInjector();
  const verbosedTheme = (0, _convertSxToSxVerbosed.convertStyledToStyledVerbosed)(theme);
  const globalStyleHash = stableHash({
    ...theme
  });
  const {
    styledIds
  } = (0, _updateOrderUnResolvedMap.updateOrderUnResolvedMap)(verbosedTheme, globalStyleHash, 'global', {}, GluestackStyleSheet, 'web');
  const toBeInjected = GluestackStyleSheet.resolve(styledIds, CONFIG, {
    propertyTokenMap: _propertyTokenMap.propertyTokenMap
  });
  const current_global_map = GluestackStyleSheet.getStyleMap();
  const orderedResolvedTheme = [];
  current_global_map === null || current_global_map === void 0 || current_global_map.forEach(styledResolved => {
    var _styledResolved$meta;
    if (styledIds.includes(styledResolved === null || styledResolved === void 0 || (_styledResolved$meta = styledResolved.meta) === null || _styledResolved$meta === void 0 ? void 0 : _styledResolved$meta.cssId)) {
      orderedResolvedTheme.push(styledResolved);
    }
  });
  return toBeInjected;
}
function extractGluestackConfig(gluestackConfig) {
  var _convertTokensToCssVa, _configWithPlatformSp;
  let configWithPlatformSpecificUnits = (0, _utils.platformSpecificSpaceUnits)({
    ...gluestackConfig
  }, 'web');
  if (gluestackConfig !== null && gluestackConfig !== void 0 && gluestackConfig.themes) {
    Object.keys(gluestackConfig.themes).forEach(key => {
      var _platformSpecificSpac;
      configWithPlatformSpecificUnits.themes[key] = (_platformSpecificSpac = (0, _utils.platformSpecificSpaceUnits)(
      //@ts-ignore
      {
        tokens: gluestackConfig.themes[key]
      }, 'web')) === null || _platformSpecificSpac === void 0 ? void 0 : _platformSpecificSpac.tokens;
    });
  }
  configWithPlatformSpecificUnits = (0, _createConfig.resolveThemes)(configWithPlatformSpecificUnits);
  let cssVariablesConovertedTokens = (_convertTokensToCssVa = (0, _utils.convertTokensToCssVariables)(configWithPlatformSpecificUnits)) === null || _convertTokensToCssVa === void 0 ? void 0 : _convertTokensToCssVa.trim('\n');
  cssVariablesConovertedTokens += '\n';
  const globalStylesCSS = extractGlobalStyles(configWithPlatformSpecificUnits, (_configWithPlatformSp = configWithPlatformSpecificUnits) === null || _configWithPlatformSp === void 0 ? void 0 : _configWithPlatformSp.globalStyle);
  Object.keys(globalStylesCSS).forEach(type => {
    globalStylesCSS[type].forEach(({
      cssRuleset
    }) => {
      cssVariablesConovertedTokens += `${cssRuleset}\n`;
    });
  });
  return cssVariablesConovertedTokens;
}
//# sourceMappingURL=extract-config.js.map